// Copyright (c) 2000-2001  David Muse
// See the file COPYING for more information

#include "../../config.h"
#include <strstream.h>
#include <iostream.h>

#include <stdlib.h>
#include <time.h>

#include <lago.h>

LCTX		lagocontext;
LRST		lagoresult;

int main(int argc, char **argv) {

	if (argc<4) {
		cout << "usage: lagotest db user password query iterations" << ENDL;
		exit(0);
	}

	char	*db=argv[1];
	char	*user=argv[2];
	char	*password=argv[3];
	char	*query=argv[4];
	int	iterations=atoi(argv[5]);

	// init the timer
	time_t	starttime=time(NULL);
	clock();

	for (int count=0; count<iterations; count++) {

		// init
		lagocontext=Lnewctx();

		// log in
		Lconnect(lagocontext,"localhost","7412",db,user,password);

		// execute the query
		lagoresult=Lquery(lagocontext,query);

		// run through the rows
		int	cols=Lgetncols(lagoresult);
		while(Lfetch(lagoresult)!=LFETCH_END) {
			for (int i=1; i<cols+1; i++) {
				cout << "\"";
				cout << Lgetasstr(lagoresult,i);
				cout << "\",";
			}
			cout << ENDL;
		}

		// log off
		Ldisconnect(lagocontext);
		Ldelctx(lagocontext);
	}

	cout << "total system time used: " << clock() << ENDL;
	cout << "total real time: " << time(NULL)-starttime << ENDL;
}
