// Copyright (c) 2000-2001  David Muse
// See the file COPYING for more information

#include "../../config.h"
#include <strstream.h>
#include <iostream.h>

#include <stdlib.h>
#include <time.h>

extern "C" {
	#include <sqlite.h>
}


sqlite		*sqliteptr;
char		*errmesg;

int	handleRow(void *parg, int argc, char **argv, char **columnnames) {

	for (int i=0; i<argc; i++) {
		cout << "\"" << argv[i] << "\",";
	}
	cout << ENDL;
	return 0;
}

int main(int argc, char **argv) {

	if (argc<4) {
		cout << "usage: sqlitetest db query iterations" << ENDL;
		exit(0);
	}

	char	*db=argv[1];
	char	*query=argv[2];
	int	iterations=atoi(argv[3]);

	// init the timer
	time_t	starttime=time(NULL);
	clock();

	for (int count=0; count<iterations; count++) {

		// log in
		sqliteptr=sqlite_open(db,666,&errmesg);

		// execute the query
		sqlite_exec(sqliteptr,query,handleRow,NULL,&errmesg);

		// log off
		sqlite_close(sqliteptr);
	}

	cout << "total system time used: " << clock() << ENDL;
	cout << "total real time: " << time(NULL)-starttime << ENDL;
}
