// Copyright (c) 1999-2001  David Muse
// See the file COPYING for more information

#include <sqlrelay/private/row.h>
#include <stdlib.h>
#include <iostream.h>

row::row(int colcount) {
	this->colcount=colcount;
	if (colcount>=OPTIMISTIC_COLUMN_COUNT) {
		extrafields=new char *[colcount-OPTIMISTIC_COLUMN_COUNT];
		extrafieldlengths=new unsigned long
					[colcount-OPTIMISTIC_COLUMN_COUNT];
	} else {
		extrafields=NULL;
		extrafieldlengths=NULL;
	}
}

row::~row() {
	if (extrafields) {
		delete[] extrafields;
		delete[] extrafieldlengths;
	}
}

void	row::resize(int colcount) {
	if (colcount>=OPTIMISTIC_COLUMN_COUNT) {
		if (extrafields) {
			delete[] extrafields;
			delete[] extrafieldlengths;
		}
		extrafields=new char *[colcount-OPTIMISTIC_COLUMN_COUNT];
		extrafieldlengths=new unsigned long
					[colcount-OPTIMISTIC_COLUMN_COUNT];
	}
}

void	row::addField(int column, char *buffer, unsigned long length) {
	if (column<OPTIMISTIC_COLUMN_COUNT) {
		fields[column]=buffer;
		fieldlengths[column]=length;
	} else {
		extrafields[column-OPTIMISTIC_COLUMN_COUNT]=buffer;
		extrafieldlengths[column-OPTIMISTIC_COLUMN_COUNT]=length;
	}
}

char	*row::getField(int column) {
	if (column<OPTIMISTIC_COLUMN_COUNT) {
		return fields[column];
	} else {
		return extrafields[column-OPTIMISTIC_COLUMN_COUNT];
	}
}

unsigned long	row::getFieldLength(int column) {
	if (column<OPTIMISTIC_COLUMN_COUNT) {
		return fieldlengths[column];
	} else {
		return extrafieldlengths[column-OPTIMISTIC_COLUMN_COUNT];
	}
}
