/* Copyright (c) 2001  David Muse
   See the file COPYING for more information */

#include <config.h>

#include "perlincludes.h"

#ifndef na
	#define na PL_na
#endif

typedef class sqlrcursor sqlrcursor;

MODULE = Firstworks::SQLRCursor		PACKAGE = Firstworks::SQLRCursor
REQUIRE: 1.925

sqlrcursor *
sqlrcursor::new(sqlrc)
		sqlrconnection *sqlrc
	CODE:
		RETVAL=new sqlrcursor(sqlrc);
		RETVAL->copyReferences();
	OUTPUT:
		RETVAL

void
sqlrcursor::DESTROY()

void
sqlrcursor::setResultSetBufferSize(rows)
		int rows

int
sqlrcursor::getResultSetBufferSize()

void
sqlrcursor::dontGetColumnInfo()

void
sqlrcursor::getColumnInfo()

void
sqlrcursor::cacheToFile(filename)
		char *filename

void
sqlrcursor::setCacheTtl(ttl)
		int ttl

char *
sqlrcursor::getCacheFileName()

void
sqlrcursor::cacheOff()

int
sqlrcursor::sendQuery(query)
		char *query

int
sqlrcursor::sendFileQuery(path,file)
		char *path
		char *file

void
sqlrcursor::prepareQuery(query)
		char *query
		

int
sqlrcursor::prepareFileQuery(path,file)
		char *path
		char *file

void
sqlrcursor::substitution(variable,...)
		char *variable
	CODE:
		if (SvIOK(ST(2))) {
			THIS->substitution(variable,(long)SvIV(ST(2)));
		} else if (SvNOK(ST(2))) {
			THIS->substitution(variable,(double)SvNV(ST(2)),
						(unsigned short)SvIV(ST(3)),
						(unsigned short)SvIV(ST(4)));
		} else if (SvPOK(ST(2))) {
			THIS->substitution(variable,SvPV(ST(2),na));
		} else {
			THIS->substitution(variable,(char *)NULL);
		}

void
sqlrcursor::clearBinds()

void
sqlrcursor::inputBind(variable,...)
		char *variable
	CODE:
		if (SvIOK(ST(2))) {
			THIS->inputBind(variable,(unsigned long)SvIV(ST(2)));
		} else if (SvNOK(ST(2))) {
			THIS->inputBind(variable,(double)SvNV(ST(2)),
						(unsigned short)SvIV(ST(3)),
						(unsigned short)SvIV(ST(4)));
		} else if (SvPOK(ST(2))) {
			THIS->inputBind(variable,SvPV(ST(2),na));
		} else {
			THIS->inputBind(variable,(char *)NULL);
		}

void
sqlrcursor::validateBinds()

int
sqlrcursor::executeQuery()

void
sqlrcursor::defineOutputBind(variable,length)
		char *variable
		int length

char *
sqlrcursor::getOutputBind(variable)
		char *variable

int
sqlrcursor::openCachedResultSet(filename)
	char	*filename

int
sqlrcursor::colCount()

int
sqlrcursor::rowCount()

int
sqlrcursor::totalRows()

int
sqlrcursor::affectedRows()

int
sqlrcursor::firstRowIndex()

int
sqlrcursor::endOfResultSet()

char *
sqlrcursor::errorMessage()

void
sqlrcursor::getNullsAsEmptyStrings()

void
sqlrcursor::getNullsAsUndefined()
	CODE:
		THIS->getNullsAsNulls();

char *
sqlrcursor::getField(row,...)
		int	row
	CODE:
		RETVAL=NULL;
		if (SvIOK(ST(2)) || SvNOK(ST(2))) {
			RETVAL=THIS->getField(row,(int)SvIV(ST(2)));
		} else if (SvPOK(ST(2))) {
			RETVAL=THIS->getField(row,SvPV(ST(2),na));
		}
	OUTPUT:
		RETVAL

long
sqlrcursor::getFieldLength(row,...)
		int	row
	CODE:
		RETVAL=NULL;
		if (SvIOK(ST(2)) || SvNOK(ST(2))) {
			RETVAL=THIS->getFieldLength(row,(int)SvIV(ST(2)));
		} else if (SvPOK(ST(2))) {
			RETVAL=THIS->getFieldLength(row,SvPV(ST(2),na));
		}
	OUTPUT:
		RETVAL

char **
sqlrcursor::getColumnNames()
	PPCODE:
		int	index=0;
		char	**namesptr=THIS->getColumnNames();
		EXTEND(SP,THIS->colCount());
		if (namesptr) {
			for (index=0; index<THIS->colCount(); index++) {
				PUSHs(sv_2mortal(newSVpv(namesptr[index],0)));
			}
		}

char *
sqlrcursor::getColumnName(col)
		int col

char *
sqlrcursor::getColumnType(...)
	CODE:
		RETVAL=NULL;
		if (SvIOK(ST(1)) || SvNOK(ST(1))) {
			RETVAL=THIS->getColumnType((int)SvIV(ST(1)));
		} else if (SvPOK(ST(1))) {
			RETVAL=THIS->getColumnType(SvPV(ST(1),na));
		}
	OUTPUT:
		RETVAL

int
sqlrcursor::getColumnLength(...)
	CODE:
		RETVAL=NULL;
		if (SvIOK(ST(1)) || SvNOK(ST(1))) {
			RETVAL=THIS->getColumnLength((int)SvIV(ST(1)));
		} else if (SvPOK(ST(1))) {
			RETVAL=THIS->getColumnLength(SvPV(ST(1),na));
		}
	OUTPUT:
		RETVAL

int
sqlrcursor::getLongest(...)
	CODE:
		RETVAL=NULL;
		if (SvIOK(ST(1)) || SvNOK(ST(1))) {
			RETVAL=THIS->getLongest((int)SvIV(ST(1)));
		} else if (SvPOK(ST(1))) {
			RETVAL=THIS->getLongest(SvPV(ST(1),na));
		}
	OUTPUT:
		RETVAL

int
sqlrcursor::getResultSetId()

void
sqlrcursor::suspendResultSet()

int
sqlrcursor::resumeResultSet(id)
		int id

int
sqlrcursor::resumeCachedResultSet(id,filename)
		int id
		char *filename
