// Copyright (c) 1999-2001  David Muse
// See the file COPYING for more information

#include <config.h>
#include <defaults.h>

#include <sqlrelay/sqlrclient.h>
#include <rudiments/commandline.h>
#if defined(HAVE_LIBXML) || defined(HAVE_GNOME_XML)
	#include <configfile.h>
#endif
#include <iostream.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int	main(int argc, char **argv) {

	#include <version.h>

	commandline	*cmdline=new commandline(argc,argv);
#if defined(HAVE_LIBXML) || defined(HAVE_GNOME_XML)
	configfile	*cfgfile=NULL;
	usernode	*currentnode=NULL;
#endif
	char		*host;
	int		port;
	char		*socket;
	char		*user;
	char		*password;
	char		*table="";

#if defined(HAVE_LIBXML) || defined(HAVE_GNOME_XML)
	char	*config=cmdline->value("-config");
	if (!(config && config[0])) {
		config=DEFAULT_CONFIG_FILE;
	}
	char	*id=id=cmdline->value("-id");

	if (!(id && id[0])) {
#endif

		if (argc<6) {
			cout << "usage: fields  host port socket ";
			cout << "user password table" << ENDL;
#if defined(HAVE_LIBXML) || defined(HAVE_GNOME_XML)
			cout << "  or   fields  [-config configfile] ";
			cout << "-id id table" << ENDL;
#endif
			exit(0);
		}

		host=argv[1];
		port=atoi(argv[2]);
		socket=argv[3];
		user=argv[4];
		password=argv[5];
		table=argv[6];

#if defined(HAVE_LIBXML) || defined(HAVE_GNOME_XML)
	} else {

		cfgfile=new configfile();
		if (cfgfile->parse(config,id)) {

			// get the host/port/socket/username/password
			host="localhost";
			port=cfgfile->getPort();
			socket=cfgfile->getUnixPort();
			currentnode=cfgfile->getUsers();
			user=currentnode->getUser();
			password=currentnode->getPassword();

			// find the query
			for (int i=1; i<argc; i++) {
				if (argv[i][0]=='-') {
					i++;
					continue;
				}
				table=argv[i];
				break;
			}
		} else {
			delete cfgfile;
			delete cmdline;
			exit(0);
		}
	}
#endif

	sqlrconnection	*sqlrcon=new sqlrconnection(host,port,socket,
						user,password,0,1);
	sqlrcursor	*sqlrcur=new sqlrcursor(sqlrcon);
	char	*query=new char[14+strlen(table)+15+1];
	sprintf(query,"select * from %s where rownum=1",table);
	sqlrcur->sendQuery(query);
	sqlrcon->endSession();
	delete[] query;

	for (int j=0; j<sqlrcur->colCount(); j++) {
		cout << sqlrcur->getColumnName(j);
		if (j<sqlrcur->colCount()-1) {
			cout << ",";
		}
	}

#if defined(HAVE_LIBXML) || defined(HAVE_GNOME_XML)
	if (cfgfile) {
		delete cfgfile;
	}
#endif
	if (cmdline) {
		delete cmdline;
	}
	delete sqlrcur;
	delete sqlrcon;
}
