// Copyright (c) 2000-2001  David Muse
// See the file COPYING for more information

#ifndef LAGOCONNECTION_H
#define LAGOCONNECTION_H

#define NUM_CONNECT_STRING_VARS 5

#include <connection.h>

#include <fstream.h>

#include <lago.h>

class lagoconnection;

class lagocursor : public cursor {
	friend class lagoconnection;
	private:
			lagocursor(connection *conn);
		int	executeQuery(char *query, long length);
		char	*getErrorMessage(int *liveconnection);
		void	returnRowCounts();
		void	returnColumnCount();
		void	returnColumnInfo();
		int	noRowsToReturn();
		int	skipRow();
		int	fetchRow();
		void	returnRow();
		void	cleanUpData();

		LRST	lagoresult;
		int	ncols;
		int	nrows;
		int	affectedrows;

		lagoconnection	*lagoconn;
};

class lagoconnection : public connection {
	friend class lagocursor;
	public:
			lagoconnection();
			~lagoconnection();
	private:
		int	getNumberOfConnectStringVars();
		void	handleConnectString();
		int	logIn();
		cursor	*initCursor();
		void	deleteCursor(cursor *curs);
		void	logOut();
		int	ping();
		char	*identify();
		int	isTransactional();
		unsigned short	autoCommitOn();
		unsigned short	autoCommitOff();
		int	commit();
		int	rollback();

		LCTX	lagocontext;

		char	*host;
		char	*port;
		char	*db;
		char	*user;
		char	*password;
};

#endif
