// Copyright (c) 2000-2001  David Muse
// See the file COPYING for more information

#ifndef MYSQLCONNECTION_H
#define MYSQLCONNECTION_H

#define NUM_CONNECT_STRING_VARS 6

#include <connection.h>

#include <fstream.h>
#include <strstream.h>

#include <mysql.h>

class mysqlconnection;

class mysqlcursor : public cursor {
	friend class mysqlconnection;
	private:
			mysqlcursor(connection *conn);
		int	executeQuery(char *query, long length);
		char	*getErrorMessage(int *liveconnection);
		void	returnRowCounts();
		void	returnColumnCount();
		void	returnColumnInfo();
		int	noRowsToReturn();
		int	skipRow();
		int	fetchRow();
		void	returnRow();
		void	cleanUpData();

		MYSQL_RES	*mysqlresult;
		MYSQL_FIELD	*mysqlfield;
		MYSQL_ROW	mysqlrow;
		int		ncols;
		int		nrows;
		int		affectedrows;
		int		queryresult;

		mysqlconnection	*mysqlconn;
};

class mysqlconnection : public connection {
	friend class mysqlcursor;
	public:
			mysqlconnection();
	private:
		int	getNumberOfConnectStringVars();
		void	handleConnectString();
		int	logIn();
		cursor	*initCursor();
		void	deleteCursor(cursor *curs);
		void	logOut();
		int	isTransactional();
		int	ping();
		char	*identify();
		unsigned short	autoCommitOn();
		unsigned short	autoCommitOff();
		int	commit();
		int	rollback();

		MYSQL	mysql;
		int	connected;

		char	*user;
		char	*password;
		char	*db;
		char	*host;
		char	*port;
		char	*socket;
};

#endif
