// Copyright (c) 1999-2001  David Muse
// See the file COPYING for more information

#include <oracle8connection.h>
#include <rudiments/signalclasses.h>

#include <iostream.h>

#include <stdlib.h>

oracle8connection	*conn;
signalhandler		*alarmhandler;

void	shutDown() {
	conn->closeConnection();
	delete conn;
	delete alarmhandler;
	exit(0);
}

int	main(int argc, char **argv) {

	#include <version.h>

	conn=new oracle8connection();

	// handle kill signals
	conn->handleShutDown((void *)shutDown);

	// handle alarm
	alarmhandler=new signalhandler(SIGALRM,(void *)shutDown);
	alarmhandler->handleSignal();

	// open the connection
	conn->initConnection(argc, argv);

	// wait for connections
	conn->listen();

	shutDown();
}
