// Copyright (c) 2001  David Muse
// See the file COPYING for more information

#include <sys/types.h>
#include <unistd.h>

#include <defaults.h>

#include <configfile.h>

#include <string.h>

#include <authenticator.h>

authenticator::authenticator(configfile *cfgfile) {

	usercount=0;
	users=NULL;
	passwords=NULL;

	// get users
	usernode	*usernodes=cfgfile->getUsers();

	usernode	*currentnode=usernodes;
	while (currentnode) {
		currentnode=currentnode->getNext();
		usercount++;
	}

	if (usercount==0) {
		users=new char *[2];
		passwords=new char *[2];

		users[0]=new char[strlen(DEFAULT_USER)+1];
		strcpy(users[0],DEFAULT_USER);

		passwords[0]=new char[strlen(DEFAULT_PASSWORD)+1];
		strcpy(passwords[0],DEFAULT_PASSWORD);

		usercount=1;
	} else {
		users=new char *[usercount];
		passwords=new char *[usercount];

		char	*user;
		char	*password;

		currentnode=usernodes;
		for (int i=0; i<usercount; i++) {

			user=currentnode->getUser();
			password=currentnode->getPassword();

			users[i]=new char[strlen(user)+1];
			strcpy(users[i],user);

			passwords[i]=new char[strlen(password)+1];
			strcpy(passwords[i],password);

			currentnode=currentnode->getNext();
		}
	}
}

authenticator::~authenticator() {
	for (int i=0; i<usercount; i++) {
		delete[] users[i];
		delete[] passwords[i];
	}
	if (users) {
		delete[] users;
	}
	if (passwords) {
		delete[] passwords;
	}
}

int	authenticator::authenticate(char *user, char *password) {

	// Return 1 if what the client sent matches one of the 
	// user/password sets and 0 if no match is found.
	for (int i=0; i<usercount; i++) {
		if (!strcmp(user,users[i]) && !strcmp(password,passwords[i])) {
			return 1;
		}
	}
	return 0;
}
